package de.johannesluderschmidt.util
{
	import flash.events.Event;
	import flash.net.FileReference;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	public class LoadFileIntoFlash{
		private const FILE_UPLOAD_URL:String = "http://your-server.com/path/to/upload/flashUpload.php";
	    private const UPLOADED_XML_URL:String = "http://your-server.com/path/to/upload/";
		
		private var fileRef:FileReference;
		
		public function LoadFileIntoFlash(){
			initializeFileRef();
		}

		private function initializeFileRef():void{
		    //FileReference allows you to open up system file chooser dialogs and to simply
		    //upload files on a webserver
		    fileRef = new FileReference();
		    
		    //after a file has been chosen in the file chooser dialog the function fileSelected
		    //will be called.
		    fileRef.addEventListener(Event.SELECT, fileSelected);
		    
		    //after the chosen file has been uploaded to the server the function uploadCompleted
		    //will be called
		    fileRef.addEventListener(Event.COMPLETE, uploadCompleted);
		}
		
		/**
		 * upload chosen file from file chooser dialog to server
		 */
		private function fileSelected(evt:Event):void {
			fileRef.upload(new URLRequest(FILE_UPLOAD_URL), "uploadFile");
		}
		
		/**
		 * load uploaded file from server into flash
		 */
		private function uploadCompleted(evt:Event):void {
			var uploadedFileUrl:String = UPLOADED_XML_URL + fileRef.name;
			var message:String;
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, downloadInFlashCompleted);
			
           loader.load(new URLRequest(uploadedFileUrl));
  		}
  		
  		/**
  		 * file has been completely loaded into Flash. You can now do with it
  		 * whatever you want to do.
  		 */
  		private function downloadInFlashCompleted(evt:Event):void {
       		trace(evt.target.data);
        }
	}
}